package com.xy.controller;

import com.xy.annotate.RestMappingController;
import com.xy.dto.DeviceDataDto;
import com.xy.service.DeviceDataServiceImpl;
import com.xy.utils.MercAuthUtils;
import com.xy.utils.PageBean;
import com.xy.utils.R;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import javax.validation.Valid;

/**
 * <p>
 *
 * </p>
 *
 * @author hechunping
 * @since 2023/3/27
 */
@RestMappingController("merc-mini/deviceData")
@AllArgsConstructor
@Api(tags = "小程序-设备销售数据统计")
public class MercMiniDeviceDataController {

    private final DeviceDataServiceImpl deviceDataService;

    @PostMapping("sumPage")
    @ApiOperation("设备销售数据统计分页")
    public R<PageBean<DeviceDataDto.SumPageVo>> sumPage(@RequestBody @Valid DeviceDataDto.SumPageDto dto){
        dto.setMercId(MercAuthUtils.getMercId());
        return R.ok(deviceDataService.sumPage(dto).getData());
    }

    @PostMapping("sumCount")
    @ApiOperation("设备销售数据统计总计")
    public R<DeviceDataDto.SumCountVo> sumCount(@RequestBody @Valid DeviceDataDto.SumCountDto dto){
        dto.setMercId(MercAuthUtils.getMercId());
        return R.ok(deviceDataService.sumCount(dto).getData());
    }
}
